#include "BmpUtil.h"

#if _MSC_VER > 1000
#pragma once
#endif 

class CNMImgButton : public CButton
{
public:
	enum BUTTON_STATE
	{
		BUTTON_ENABLE = 0,
		BUTTON_HOVER,
		BUTTON_CLICK,
		BUTTON_DISABLE
	};

	void			SetBtnBitmapFile(CString strFileName,UINT nMakse); 	
	void			SetButtonEnable();
	void			SetButtonDisable();	
	void			SetToolTipText(CString strText);
	BOOL			EnableWindow(BOOL bEnable = TRUE);	// Disable Ǿ ڻ ٲپ ش.
	void			EnableHandCursor(BOOL bUseHand);

public:
	CNMImgButton();
	virtual ~CNMImgButton();

public:
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	virtual BOOL PreTranslateMessage(MSG* pMsg);

	void SetSelected(bool bSelected = true);
	BOOL			m_bUISelected;

	int				GetImgWidth();
	int				GetImgHeight();

	// tracking
	BOOL			m_bTracking;

	void			SetBmpFont(CFont* pFont)		{ m_bmpImage.SetBmpFont(pFont); }
	void			SetBmpFontColor(COLORREF col);

	// text
	CString			m_strBmpText;

	void			SetBmpText(CString strText)		{ m_strBmpText = strText; }
	CString			GetBmpText()					{ return m_strBmpText; }


protected:	
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);

	afx_msg LRESULT OnMouseLeave(WPARAM wparam, LPARAM lparam);
	afx_msg LRESULT OnMouseHover(WPARAM wparam, LPARAM lparam);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

	DECLARE_MESSAGE_MAP()

private:
	CBmpUtil		m_bmpImage;			
	UINT			m_nMask;			
	BOOL			m_bDisable;			
	CRect			m_rectButton;		
	CRect			m_rectButtonPos;	
	BOOL			m_bHover;			
	CToolTipCtrl	m_ToolTip;	
	COLORREF		m_crText;
	BOOL			m_bUseHandCursor;
};

